"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Downloader = void 0;
const axios_1 = __importDefault(require("axios"));
const interfaces_1 = require("./interfaces");
const path = __importStar(require("path"));
const fs = __importStar(require("fs"));
class Downloader {
    constructor(DownloaderOptions) {
        this.NodeCount = 5;
        this.endPoints = {
            status: "download/status",
            file: "details/file",
            download: "download/request",
            storage: "storage"
        };
        if (DownloaderOptions == null)
            DownloaderOptions = {
                apiPrefix: "prod/api",
                apiVersion: "node0" + (Math.floor(Math.random() * this.NodeCount) + 1),
                userAgent: "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/97.0.4692.99 Safari/537.36 OPR/83.0.4254.62"
            };
        this.options = DownloaderOptions;
        this.client = axios_1.default.create({
            baseURL: `https://${this.options.apiVersion}.steamworkshopdownloader.io/${this.options.apiPrefix}/`,
            headers: {
                "User-Agent": this.options.userAgent
            }
        });
    }
    sleep(ms) {
        return new Promise(resolve => setTimeout(resolve, ms));
    }
    Info(WorkshopID) {
        return __awaiter(this, void 0, void 0, function* () {
            let Donut = {
                success: false
            };
            var Request = null;
            try {
                Request = (yield this.client.post(this.endPoints.file, `[${WorkshopID.toString()}]:`)).data;
            }
            catch (ex) {
                Donut.success = false;
                Donut.message = ex.message;
                return Donut;
            }
            if (Request.length <= 0) {
                Donut.success = false;
                Donut.message = "Cant find item(s) with id(s)";
                return Donut;
            }
            var Data = [];
            Request.forEach((SingleItem) => __awaiter(this, void 0, void 0, function* () {
                var ItemInfo = {
                    id: Number(SingleItem.publishedfileid),
                    title: SingleItem.title,
                    safeTitle: SingleItem.title_disk_safe,
                    appName: SingleItem.app_name,
                    image: SingleItem.file_url,
                    size: Number(SingleItem.file_size),
                    uploadedDate: SingleItem.time_created,
                    downloadType: SingleItem.download_format == "raw" ? interfaces_1.DownloadType.Raw : interfaces_1.DownloadType.GmaExtract,
                    fileType: SingleItem.file_type
                };
                if (SingleItem.children != null && SingleItem.children.length > 0)
                    ItemInfo.childs = SingleItem.children.map((x) => ({ id: x.publishedfileid }));
                Data.push(ItemInfo);
            }));
            Donut.success = true;
            Donut.data = Data;
            return Donut;
        });
    }
    Download(WorkshopID, DownPath) {
        var e_1, _a, e_2, _b;
        var _c;
        return __awaiter(this, void 0, void 0, function* () {
            let Donut = {
                success: false,
                data: []
            };
            var Infos = (yield this.Info(WorkshopID)).data;
            if (Infos == null) {
                Donut.message = "Cant fetch workshop(s) item(s).";
                return Donut;
            }
            var DownCollection = [];
            try {
                for (var Infos_1 = __asyncValues(Infos), Infos_1_1; Infos_1_1 = yield Infos_1.next(), !Infos_1_1.done;) {
                    const SingleInfo = Infos_1_1.value;
                    try {
                        var Request = (yield this.client.post(this.endPoints.download, {
                            publishedFileId: SingleInfo.id,
                            collectionId: null,
                            hidden: false,
                            downloadFormat: interfaces_1.DownloadType[SingleInfo.downloadType].toLowerCase(),
                            autodownload: false
                        })).data;
                        if ((Request === null || Request === void 0 ? void 0 : Request.uuid) != null)
                            DownCollection.push({ item: SingleInfo, uuid: Request.uuid, progress: { progress: 0, status: interfaces_1.DownloadStatus.dequeued } });
                    }
                    catch (ex) {
                        console.warn(ex.message);
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (Infos_1_1 && !Infos_1_1.done && (_a = Infos_1.return)) yield _a.call(Infos_1);
                }
                finally { if (e_1) throw e_1.error; }
            }
            var GetStatusOfCollection = (yield this.client.post(this.endPoints.status, {
                uuids: DownCollection.map(x => x.uuid)
            })).data;
            DownCollection.forEach(SingleDown => {
                var Statu = GetStatusOfCollection[SingleDown.uuid];
                if (Statu != null)
                    var StatuType = interfaces_1.DownloadStatus.dequeued;
                switch (Statu.status) {
                    case "prepared":
                        StatuType = interfaces_1.DownloadStatus.prepared;
                        break;
                    case "transmitted":
                        StatuType = interfaces_1.DownloadStatus.transmitted;
                        break;
                    default:
                        StatuType = interfaces_1.DownloadStatus.dequeued;
                        break;
                }
                SingleDown.progress = { progress: Number(Statu.progress), status: StatuType };
            });
            var WillBeDownloaded = DownCollection.filter(x => x.progress != null);
            while (WillBeDownloaded.filter(x => { var _a; return ((_a = x.progress) === null || _a === void 0 ? void 0 : _a.status) == interfaces_1.DownloadStatus.prepared; }).length != WillBeDownloaded.length) {
                let stats = (yield this.client.post(this.endPoints.status, {
                    uuids: WillBeDownloaded.map(x => x.uuid)
                })).data;
                var StatusUIDS = Object.keys(stats);
                StatusUIDS.forEach((SingleID) => {
                    var Bul = WillBeDownloaded.find(x => x.uuid == SingleID);
                    if (Bul != null || Bul != undefined) {
                        var StatFromID = stats[SingleID];
                        Bul.progress.progress = StatFromID.progress;
                        if (StatFromID.status == "prepared") {
                            Bul.path = "https://" + StatFromID.storageNode + "/prod//storage/" + StatFromID.storagePath;
                            Bul.progress.status = interfaces_1.DownloadStatus.prepared;
                        }
                        else {
                            Bul.progress.status = interfaces_1.DownloadStatus.transmitted;
                        }
                    }
                });
                yield this.sleep(1000);
            }
            if (fs.existsSync(path.resolve(DownPath)) == false)
                fs.mkdirSync(path.resolve(DownPath));
            try {
                for (var WillBeDownloaded_1 = __asyncValues(WillBeDownloaded), WillBeDownloaded_1_1; WillBeDownloaded_1_1 = yield WillBeDownloaded_1.next(), !WillBeDownloaded_1_1.done;) {
                    const SingleDown = WillBeDownloaded_1_1.value;
                    var DownloadRes = (yield (0, axios_1.default)({
                        url: SingleDown.path + "?uuid=" + SingleDown.uuid,
                        method: 'GET',
                        responseType: 'stream'
                    })).data;
                    var FileName = SingleDown.item.safeTitle != '' ? SingleDown.item.safeTitle : SingleDown.item.appName;
                    var DownloadedPath = path.join(path.resolve(DownPath), FileName + ".zip");
                    var DownloadedSize = 0;
                    var EndedDownload = false;
                    const Writer = fs.createWriteStream(DownloadedPath);
                    DownloadRes.pipe(Writer);
                    DownloadRes.on("data", (chunk) => {
                        DownloadedSize += chunk.length;
                    });
                    DownloadRes.on('end', function () {
                        EndedDownload = true;
                    });
                    while (EndedDownload == false) {
                        console.log(DownloadedSize + " kb Downloaded | Downloading... | " + DownloadedPath);
                        yield this.sleep(1000);
                    }
                    (_c = Donut.data) === null || _c === void 0 ? void 0 : _c.push({
                        path: DownloadedPath,
                        size: DownloadedSize
                    });
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (WillBeDownloaded_1_1 && !WillBeDownloaded_1_1.done && (_b = WillBeDownloaded_1.return)) yield _b.call(WillBeDownloaded_1);
                }
                finally { if (e_2) throw e_2.error; }
            }
            Donut.success = true;
            return Donut;
        });
    }
}
exports.Downloader = Downloader;
